# gtslib-auth-keyring

[![Build Status](https://build.coopcloud.tech/api/badges/decentral1se/gtslib-auth-keyring/status.svg?ref=refs/heads/main)](https://build.coopcloud.tech/decentral1se/gtslib-auth-keyring)
[![Go Report Card](https://goreportcard.com/badge/git.coopcloud.tech/decentral1se/gtslib-auth-keyring)](https://goreportcard.com/report/git.coopcloud.tech/decentral1se/gtslib-auth-keyring)
[![Go Reference](https://pkg.go.dev/badge/git.coopcloud.tech/gtslib-auth-keyring.svg)](https://pkg.go.dev/git.coopcloud.tech/gtslib-auth-keyring)

> [GoToSocial](https://gotosocial.org) client auth with keyring support

**ALPHA SOFTWARE** just like GoToSocial. Uses [`go-keyring`](https://github.com/zalando/go-keyring).

```go
import (
  "log/slog"

  auth "git.coopcloud.tech/decentral1se/gtslib-auth-keyring"
)

func main() {
  if err := auth.Login("foo@bar.zone"); err != nil {
    slog.Error("unable to login", "error", err)
  }
}
```

## ACK

Made possible by the good work of [`slurp`](https://github.com/VyrCossont/slurp).

## License

<a href="https://git.coopcloud.tech/decentral1se/gtslib-auth-keyring/src/branch/main/LICENSE">
  <img src="https://www.gnu.org/graphics/agplv3-with-text-162x68.png" />
</a>
