// Code generated by go-swagger; DO NOT EDIT.

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAccountBlockParams creates a new AccountBlockParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAccountBlockParams() *AccountBlockParams {
	return &AccountBlockParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAccountBlockParamsWithTimeout creates a new AccountBlockParams object
// with the ability to set a timeout on a request.
func NewAccountBlockParamsWithTimeout(timeout time.Duration) *AccountBlockParams {
	return &AccountBlockParams{
		timeout: timeout,
	}
}

// NewAccountBlockParamsWithContext creates a new AccountBlockParams object
// with the ability to set a context for a request.
func NewAccountBlockParamsWithContext(ctx context.Context) *AccountBlockParams {
	return &AccountBlockParams{
		Context: ctx,
	}
}

// NewAccountBlockParamsWithHTTPClient creates a new AccountBlockParams object
// with the ability to set a custom HTTPClient for a request.
func NewAccountBlockParamsWithHTTPClient(client *http.Client) *AccountBlockParams {
	return &AccountBlockParams{
		HTTPClient: client,
	}
}

/*
AccountBlockParams contains all the parameters to send to the API endpoint

	for the account block operation.

	Typically these are written to a http.Request.
*/
type AccountBlockParams struct {

	/* ID.

	   The id of the account to block.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the account block params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccountBlockParams) WithDefaults() *AccountBlockParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the account block params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccountBlockParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the account block params
func (o *AccountBlockParams) WithTimeout(timeout time.Duration) *AccountBlockParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the account block params
func (o *AccountBlockParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the account block params
func (o *AccountBlockParams) WithContext(ctx context.Context) *AccountBlockParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the account block params
func (o *AccountBlockParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the account block params
func (o *AccountBlockParams) WithHTTPClient(client *http.Client) *AccountBlockParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the account block params
func (o *AccountBlockParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the account block params
func (o *AccountBlockParams) WithID(id string) *AccountBlockParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the account block params
func (o *AccountBlockParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *AccountBlockParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
