// Code generated by go-swagger; DO NOT EDIT.

package conversations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewConversationDeleteParams creates a new ConversationDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewConversationDeleteParams() *ConversationDeleteParams {
	return &ConversationDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewConversationDeleteParamsWithTimeout creates a new ConversationDeleteParams object
// with the ability to set a timeout on a request.
func NewConversationDeleteParamsWithTimeout(timeout time.Duration) *ConversationDeleteParams {
	return &ConversationDeleteParams{
		timeout: timeout,
	}
}

// NewConversationDeleteParamsWithContext creates a new ConversationDeleteParams object
// with the ability to set a context for a request.
func NewConversationDeleteParamsWithContext(ctx context.Context) *ConversationDeleteParams {
	return &ConversationDeleteParams{
		Context: ctx,
	}
}

// NewConversationDeleteParamsWithHTTPClient creates a new ConversationDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewConversationDeleteParamsWithHTTPClient(client *http.Client) *ConversationDeleteParams {
	return &ConversationDeleteParams{
		HTTPClient: client,
	}
}

/*
ConversationDeleteParams contains all the parameters to send to the API endpoint

	for the conversation delete operation.

	Typically these are written to a http.Request.
*/
type ConversationDeleteParams struct {

	/* ID.

	   ID of the conversation
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the conversation delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConversationDeleteParams) WithDefaults() *ConversationDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the conversation delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConversationDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the conversation delete params
func (o *ConversationDeleteParams) WithTimeout(timeout time.Duration) *ConversationDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the conversation delete params
func (o *ConversationDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the conversation delete params
func (o *ConversationDeleteParams) WithContext(ctx context.Context) *ConversationDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the conversation delete params
func (o *ConversationDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the conversation delete params
func (o *ConversationDeleteParams) WithHTTPClient(client *http.Client) *ConversationDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the conversation delete params
func (o *ConversationDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the conversation delete params
func (o *ConversationDeleteParams) WithID(id string) *ConversationDeleteParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the conversation delete params
func (o *ConversationDeleteParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *ConversationDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
