// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusGetParams creates a new StatusGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusGetParams() *StatusGetParams {
	return &StatusGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusGetParamsWithTimeout creates a new StatusGetParams object
// with the ability to set a timeout on a request.
func NewStatusGetParamsWithTimeout(timeout time.Duration) *StatusGetParams {
	return &StatusGetParams{
		timeout: timeout,
	}
}

// NewStatusGetParamsWithContext creates a new StatusGetParams object
// with the ability to set a context for a request.
func NewStatusGetParamsWithContext(ctx context.Context) *StatusGetParams {
	return &StatusGetParams{
		Context: ctx,
	}
}

// NewStatusGetParamsWithHTTPClient creates a new StatusGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusGetParamsWithHTTPClient(client *http.Client) *StatusGetParams {
	return &StatusGetParams{
		HTTPClient: client,
	}
}

/*
StatusGetParams contains all the parameters to send to the API endpoint

	for the status get operation.

	Typically these are written to a http.Request.
*/
type StatusGetParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusGetParams) WithDefaults() *StatusGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status get params
func (o *StatusGetParams) WithTimeout(timeout time.Duration) *StatusGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status get params
func (o *StatusGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status get params
func (o *StatusGetParams) WithContext(ctx context.Context) *StatusGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status get params
func (o *StatusGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status get params
func (o *StatusGetParams) WithHTTPClient(client *http.Client) *StatusGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status get params
func (o *StatusGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status get params
func (o *StatusGetParams) WithID(id string) *StatusGetParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status get params
func (o *StatusGetParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
