// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusUnfaveParams creates a new StatusUnfaveParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusUnfaveParams() *StatusUnfaveParams {
	return &StatusUnfaveParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusUnfaveParamsWithTimeout creates a new StatusUnfaveParams object
// with the ability to set a timeout on a request.
func NewStatusUnfaveParamsWithTimeout(timeout time.Duration) *StatusUnfaveParams {
	return &StatusUnfaveParams{
		timeout: timeout,
	}
}

// NewStatusUnfaveParamsWithContext creates a new StatusUnfaveParams object
// with the ability to set a context for a request.
func NewStatusUnfaveParamsWithContext(ctx context.Context) *StatusUnfaveParams {
	return &StatusUnfaveParams{
		Context: ctx,
	}
}

// NewStatusUnfaveParamsWithHTTPClient creates a new StatusUnfaveParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusUnfaveParamsWithHTTPClient(client *http.Client) *StatusUnfaveParams {
	return &StatusUnfaveParams{
		HTTPClient: client,
	}
}

/*
StatusUnfaveParams contains all the parameters to send to the API endpoint

	for the status unfave operation.

	Typically these are written to a http.Request.
*/
type StatusUnfaveParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status unfave params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusUnfaveParams) WithDefaults() *StatusUnfaveParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status unfave params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusUnfaveParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status unfave params
func (o *StatusUnfaveParams) WithTimeout(timeout time.Duration) *StatusUnfaveParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status unfave params
func (o *StatusUnfaveParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status unfave params
func (o *StatusUnfaveParams) WithContext(ctx context.Context) *StatusUnfaveParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status unfave params
func (o *StatusUnfaveParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status unfave params
func (o *StatusUnfaveParams) WithHTTPClient(client *http.Client) *StatusUnfaveParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status unfave params
func (o *StatusUnfaveParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status unfave params
func (o *StatusUnfaveParams) WithID(id string) *StatusUnfaveParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status unfave params
func (o *StatusUnfaveParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusUnfaveParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
