// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusUnmuteParams creates a new StatusUnmuteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusUnmuteParams() *StatusUnmuteParams {
	return &StatusUnmuteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusUnmuteParamsWithTimeout creates a new StatusUnmuteParams object
// with the ability to set a timeout on a request.
func NewStatusUnmuteParamsWithTimeout(timeout time.Duration) *StatusUnmuteParams {
	return &StatusUnmuteParams{
		timeout: timeout,
	}
}

// NewStatusUnmuteParamsWithContext creates a new StatusUnmuteParams object
// with the ability to set a context for a request.
func NewStatusUnmuteParamsWithContext(ctx context.Context) *StatusUnmuteParams {
	return &StatusUnmuteParams{
		Context: ctx,
	}
}

// NewStatusUnmuteParamsWithHTTPClient creates a new StatusUnmuteParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusUnmuteParamsWithHTTPClient(client *http.Client) *StatusUnmuteParams {
	return &StatusUnmuteParams{
		HTTPClient: client,
	}
}

/*
StatusUnmuteParams contains all the parameters to send to the API endpoint

	for the status unmute operation.

	Typically these are written to a http.Request.
*/
type StatusUnmuteParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status unmute params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusUnmuteParams) WithDefaults() *StatusUnmuteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status unmute params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusUnmuteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status unmute params
func (o *StatusUnmuteParams) WithTimeout(timeout time.Duration) *StatusUnmuteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status unmute params
func (o *StatusUnmuteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status unmute params
func (o *StatusUnmuteParams) WithContext(ctx context.Context) *StatusUnmuteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status unmute params
func (o *StatusUnmuteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status unmute params
func (o *StatusUnmuteParams) WithHTTPClient(client *http.Client) *StatusUnmuteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status unmute params
func (o *StatusUnmuteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status unmute params
func (o *StatusUnmuteParams) WithID(id string) *StatusUnmuteParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status unmute params
func (o *StatusUnmuteParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusUnmuteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
