// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusUnpinParams creates a new StatusUnpinParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusUnpinParams() *StatusUnpinParams {
	return &StatusUnpinParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusUnpinParamsWithTimeout creates a new StatusUnpinParams object
// with the ability to set a timeout on a request.
func NewStatusUnpinParamsWithTimeout(timeout time.Duration) *StatusUnpinParams {
	return &StatusUnpinParams{
		timeout: timeout,
	}
}

// NewStatusUnpinParamsWithContext creates a new StatusUnpinParams object
// with the ability to set a context for a request.
func NewStatusUnpinParamsWithContext(ctx context.Context) *StatusUnpinParams {
	return &StatusUnpinParams{
		Context: ctx,
	}
}

// NewStatusUnpinParamsWithHTTPClient creates a new StatusUnpinParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusUnpinParamsWithHTTPClient(client *http.Client) *StatusUnpinParams {
	return &StatusUnpinParams{
		HTTPClient: client,
	}
}

/*
StatusUnpinParams contains all the parameters to send to the API endpoint

	for the status unpin operation.

	Typically these are written to a http.Request.
*/
type StatusUnpinParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status unpin params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusUnpinParams) WithDefaults() *StatusUnpinParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status unpin params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusUnpinParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status unpin params
func (o *StatusUnpinParams) WithTimeout(timeout time.Duration) *StatusUnpinParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status unpin params
func (o *StatusUnpinParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status unpin params
func (o *StatusUnpinParams) WithContext(ctx context.Context) *StatusUnpinParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status unpin params
func (o *StatusUnpinParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status unpin params
func (o *StatusUnpinParams) WithHTTPClient(client *http.Client) *StatusUnpinParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status unpin params
func (o *StatusUnpinParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status unpin params
func (o *StatusUnpinParams) WithID(id string) *StatusUnpinParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status unpin params
func (o *StatusUnpinParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusUnpinParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
