// Code generated by go-swagger; DO NOT EDIT.

package timelines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewTagTimelineParams creates a new TagTimelineParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTagTimelineParams() *TagTimelineParams {
	return &TagTimelineParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTagTimelineParamsWithTimeout creates a new TagTimelineParams object
// with the ability to set a timeout on a request.
func NewTagTimelineParamsWithTimeout(timeout time.Duration) *TagTimelineParams {
	return &TagTimelineParams{
		timeout: timeout,
	}
}

// NewTagTimelineParamsWithContext creates a new TagTimelineParams object
// with the ability to set a context for a request.
func NewTagTimelineParamsWithContext(ctx context.Context) *TagTimelineParams {
	return &TagTimelineParams{
		Context: ctx,
	}
}

// NewTagTimelineParamsWithHTTPClient creates a new TagTimelineParams object
// with the ability to set a custom HTTPClient for a request.
func NewTagTimelineParamsWithHTTPClient(client *http.Client) *TagTimelineParams {
	return &TagTimelineParams{
		HTTPClient: client,
	}
}

/*
TagTimelineParams contains all the parameters to send to the API endpoint

	for the tag timeline operation.

	Typically these are written to a http.Request.
*/
type TagTimelineParams struct {

	/* Limit.

	   Number of statuses to return.

	   Default: 20
	*/
	Limit *int64

	/* MaxID.

	   Return only statuses *OLDER* than the given max status ID. The status with the specified ID will not be included in the response.
	*/
	MaxID *string

	/* MinID.

	   Return only statuses *immediately newer* than the given since status ID. The status with the specified ID will not be included in the response.
	*/
	MinID *string

	/* SinceID.

	   Return only statuses *newer* than the given since status ID. The status with the specified ID will not be included in the response.
	*/
	SinceID *string

	/* TagName.

	   Name of the tag
	*/
	TagName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the tag timeline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TagTimelineParams) WithDefaults() *TagTimelineParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the tag timeline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TagTimelineParams) SetDefaults() {
	var (
		limitDefault = int64(20)
	)

	val := TagTimelineParams{
		Limit: &limitDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the tag timeline params
func (o *TagTimelineParams) WithTimeout(timeout time.Duration) *TagTimelineParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the tag timeline params
func (o *TagTimelineParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the tag timeline params
func (o *TagTimelineParams) WithContext(ctx context.Context) *TagTimelineParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the tag timeline params
func (o *TagTimelineParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the tag timeline params
func (o *TagTimelineParams) WithHTTPClient(client *http.Client) *TagTimelineParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the tag timeline params
func (o *TagTimelineParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the tag timeline params
func (o *TagTimelineParams) WithLimit(limit *int64) *TagTimelineParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the tag timeline params
func (o *TagTimelineParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithMaxID adds the maxID to the tag timeline params
func (o *TagTimelineParams) WithMaxID(maxID *string) *TagTimelineParams {
	o.SetMaxID(maxID)
	return o
}

// SetMaxID adds the maxId to the tag timeline params
func (o *TagTimelineParams) SetMaxID(maxID *string) {
	o.MaxID = maxID
}

// WithMinID adds the minID to the tag timeline params
func (o *TagTimelineParams) WithMinID(minID *string) *TagTimelineParams {
	o.SetMinID(minID)
	return o
}

// SetMinID adds the minId to the tag timeline params
func (o *TagTimelineParams) SetMinID(minID *string) {
	o.MinID = minID
}

// WithSinceID adds the sinceID to the tag timeline params
func (o *TagTimelineParams) WithSinceID(sinceID *string) *TagTimelineParams {
	o.SetSinceID(sinceID)
	return o
}

// SetSinceID adds the sinceId to the tag timeline params
func (o *TagTimelineParams) SetSinceID(sinceID *string) {
	o.SinceID = sinceID
}

// WithTagName adds the tagName to the tag timeline params
func (o *TagTimelineParams) WithTagName(tagName string) *TagTimelineParams {
	o.SetTagName(tagName)
	return o
}

// SetTagName adds the tagName to the tag timeline params
func (o *TagTimelineParams) SetTagName(tagName string) {
	o.TagName = tagName
}

// WriteToRequest writes these params to a swagger request
func (o *TagTimelineParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.MaxID != nil {

		// query param max_id
		var qrMaxID string

		if o.MaxID != nil {
			qrMaxID = *o.MaxID
		}
		qMaxID := qrMaxID
		if qMaxID != "" {

			if err := r.SetQueryParam("max_id", qMaxID); err != nil {
				return err
			}
		}
	}

	if o.MinID != nil {

		// query param min_id
		var qrMinID string

		if o.MinID != nil {
			qrMinID = *o.MinID
		}
		qMinID := qrMinID
		if qMinID != "" {

			if err := r.SetQueryParam("min_id", qMinID); err != nil {
				return err
			}
		}
	}

	if o.SinceID != nil {

		// query param since_id
		var qrSinceID string

		if o.SinceID != nil {
			qrSinceID = *o.SinceID
		}
		qSinceID := qrSinceID
		if qSinceID != "" {

			if err := r.SetQueryParam("since_id", qSinceID); err != nil {
				return err
			}
		}
	}

	// path param tag_name
	if err := r.SetPathParam("tag_name", o.TagName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
