// Code generated by go-swagger; DO NOT EDIT.

package timelines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// New creates a new timelines API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

// New creates a new timelines API client with basic auth credentials.
// It takes the following parameters:
// - host: http host (github.com).
// - basePath: any base path for the API client ("/v1", "/v3").
// - scheme: http scheme ("http", "https").
// - user: user for basic authentication header.
// - password: password for basic authentication header.
func NewClientWithBasicAuth(host, basePath, scheme, user, password string) ClientService {
	transport := httptransport.New(host, basePath, []string{scheme})
	transport.DefaultAuthentication = httptransport.BasicAuth(user, password)
	return &Client{transport: transport, formats: strfmt.Default}
}

// New creates a new timelines API client with a bearer token for authentication.
// It takes the following parameters:
// - host: http host (github.com).
// - basePath: any base path for the API client ("/v1", "/v3").
// - scheme: http scheme ("http", "https").
// - bearerToken: bearer token for Bearer authentication header.
func NewClientWithBearerToken(host, basePath, scheme, bearerToken string) ClientService {
	transport := httptransport.New(host, basePath, []string{scheme})
	transport.DefaultAuthentication = httptransport.BearerToken(bearerToken)
	return &Client{transport: transport, formats: strfmt.Default}
}

/*
Client for timelines API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption may be used to customize the behavior of Client methods.
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	HomeTimeline(params *HomeTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*HomeTimelineOK, error)

	ListTimeline(params *ListTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*ListTimelineOK, error)

	PublicTimeline(params *PublicTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PublicTimelineOK, error)

	TagTimeline(params *TagTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*TagTimelineOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
	HomeTimeline sees statuses posts by accounts you follow

	The statuses will be returned in descending chronological order (newest first), with sequential IDs (bigger = newer).

The returned Link header can be used to generate the previous and next queries when scrolling up or down a timeline.

Example:

```
<https://example.org/api/v1/timelines/home?limit=20&max_id=01FC3GSQ8A3MMJ43BPZSGEG29M>; rel="next", <https://example.org/api/v1/timelines/home?limit=20&min_id=01FC3KJW2GYXSDDRA6RWNDM46M>; rel="prev"
````
*/
func (a *Client) HomeTimeline(params *HomeTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*HomeTimelineOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewHomeTimelineParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "homeTimeline",
		Method:             "GET",
		PathPattern:        "/api/v1/timelines/home",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &HomeTimelineReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*HomeTimelineOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for homeTimeline: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
	ListTimeline sees statuses posts from the given list timeline

	The statuses will be returned in descending chronological order (newest first), with sequential IDs (bigger = newer).

The returned Link header can be used to generate the previous and next queries when scrolling up or down a timeline.

Example:

```
<https://example.org/api/v1/timelines/list/01H0W619198FX7J54NF7EH1NG2?limit=20&max_id=01FC3GSQ8A3MMJ43BPZSGEG29M>; rel="next", <https://example.org/api/v1/timelines/list/01H0W619198FX7J54NF7EH1NG2?limit=20&min_id=01FC3KJW2GYXSDDRA6RWNDM46M>; rel="prev"
````
*/
func (a *Client) ListTimeline(params *ListTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*ListTimelineOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewListTimelineParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "listTimeline",
		Method:             "GET",
		PathPattern:        "/api/v1/timelines/list/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListTimelineReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*ListTimelineOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for listTimeline: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
	PublicTimeline sees public statuses posts that your instance is aware of

	The statuses will be returned in descending chronological order (newest first), with sequential IDs (bigger = newer).

The returned Link header can be used to generate the previous and next queries when scrolling up or down a timeline.

Example:

```
<https://example.org/api/v1/timelines/public?limit=20&max_id=01FC3GSQ8A3MMJ43BPZSGEG29M>; rel="next", <https://example.org/api/v1/timelines/public?limit=20&min_id=01FC3KJW2GYXSDDRA6RWNDM46M>; rel="prev"
````
*/
func (a *Client) PublicTimeline(params *PublicTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PublicTimelineOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPublicTimelineParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "publicTimeline",
		Method:             "GET",
		PathPattern:        "/api/v1/timelines/public",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &PublicTimelineReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PublicTimelineOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for publicTimeline: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
	TagTimeline sees public statuses that use the given hashtag case insensitive

	The statuses will be returned in descending chronological order (newest first), with sequential IDs (bigger = newer).

The returned Link header can be used to generate the previous and next queries when scrolling up or down a timeline.

Example:

```
<https://example.org/api/v1/timelines/tag/example?limit=20&max_id=01FC3GSQ8A3MMJ43BPZSGEG29M>; rel="next", <https://example.org/api/v1/timelines/tag/example?limit=20&min_id=01FC3KJW2GYXSDDRA6RWNDM46M>; rel="prev"
````
*/
func (a *Client) TagTimeline(params *TagTimelineParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*TagTimelineOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewTagTimelineParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "tagTimeline",
		Method:             "GET",
		PathPattern:        "/api/v1/timelines/tag/{tag_name}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &TagTimelineReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*TagTimelineOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for tagTimeline: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
