// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// InstanceConfigurationMediaAttachments InstanceConfigurationMediaAttachments models instance media attachment config parameters.
//
// swagger:model InstanceConfigurationMediaAttachments
type InstanceConfigurationMediaAttachments struct {

	// Max allowed image size in pixels as height*width.
	//
	// GtS doesn't set a limit on this, but for compatibility
	// we give Mastodon's 4096x4096px value here.
	// Example: 16777216
	ImageMatrixLimit int64 `json:"image_matrix_limit,omitempty"`

	// Max allowed image size in bytes
	// Example: 2097152
	ImageSizeLimit int64 `json:"image_size_limit,omitempty"`

	// List of mime types that it's possible to upload to this instance.
	// Example: ["image/jpeg","image/gif"]
	SupportedMimeTypes []string `json:"supported_mime_types"`

	// Max allowed video frame rate.
	// Example: 60
	VideoFrameRateLimit int64 `json:"video_frame_rate_limit,omitempty"`

	// Max allowed video size in pixels as height*width.
	//
	// GtS doesn't set a limit on this, but for compatibility
	// we give Mastodon's 4096x4096px value here.
	// Example: 16777216
	VideoMatrixLimit int64 `json:"video_matrix_limit,omitempty"`

	// Max allowed video size in bytes
	// Example: 10485760
	VideoSizeLimit int64 `json:"video_size_limit,omitempty"`
}

// Validate validates this instance configuration media attachments
func (m *InstanceConfigurationMediaAttachments) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this instance configuration media attachments based on context it is used
func (m *InstanceConfigurationMediaAttachments) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *InstanceConfigurationMediaAttachments) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *InstanceConfigurationMediaAttachments) UnmarshalBinary(b []byte) error {
	var res InstanceConfigurationMediaAttachments
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
